OGRE: Ogre::HighLevelGpuProgram Class Reference - OGRE Documentation

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes

# Ogre::HighLevelGpuProgram Class Reference
[Resources]

Abstract base class representing a high-level program (a vertex or fragment program). More...

`#include <OgreHighLevelGpuProgram.h>`

Inheritance diagram for Ogre::HighLevelGpuProgram:
[legend]

List of all members.

## Public Types
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
## Public Member Functions
| HighLevelGpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, should be used only by factory classes.
| ~HighLevelGpuProgram ()
GpuProgramParametersSharedPtr | createParameters (void)
| Creates a new parameters object compatible with this program definition.
GpuProgram * | _getBindingDelegate (void)
const GpuNamedConstants & | getConstantDefinitions () const
| Get the full list of GpuConstantDefinition instances.
const GpuNamedConstants & | getNamedConstants () const
| Override GpuProgram::getNamedConstants to ensure built.
virtual void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
virtual void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
virtual const String & | getSyntaxCode (void) const
| Gets the syntax code for this program e.g.
virtual void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
virtual const String & | getSourceFile (void) const
| Gets the name of the file used as source for this program.
virtual const String & | getSource (void) const
| Gets the assembler source for this program.
virtual void | setType (GpuProgramType t)
| Set the program type (only valid before load).
virtual GpuProgramType | getType (void) const
| Get the program type.
virtual bool | isSupported (void) const
| Returns whether this program can be supported on the current renderer and hardware.
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform skeletal animation.
virtual bool | isSkeletalAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform skeletal animation.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform morph animation.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program includes the required instructions to perform pose animation.
virtual bool | isMorphAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform morph animation.
virtual bool | isPoseAnimationIncluded (void) const
| Returns whether a vertex program includes the required instructions to perform pose animation.
virtual ushort | getNumberOfPosesIncluded (void) const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
virtual bool | isVertexTextureFetchRequired (void) const
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
virtual void | setAdjacencyInfoRequired (bool r)
| Sets whether this geometry program requires adjacency information from the input primitives.
virtual bool | isAdjacencyInfoRequired (void) const
| Returns whether this geometry program requires adjacency information from the input primitives.
virtual GpuProgramParametersSharedPtr | getDefaultParameters (void)
| Get a reference to the default parameters which are to be used for all uses of this program.
virtual bool | hasDefaultParameters (void) const
| Returns true if default parameters have been set up.
virtual bool | getPassSurfaceAndLightStates (void) const
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).
virtual bool | getPassFogStates (void) const
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).
virtual bool | getPassTransformStates (void) const
| Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.
virtual const String & | getLanguage (void) const
| Returns a string that specifies the language of the gpu programs as specified in a material script.
virtual bool | hasCompileError (void) const
| Did this program encounter a compile error when loading?
virtual void | resetCompileError (void)
| Reset a compile error if it occurred, allowing the load to be retried.
virtual void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.
virtual void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual const String & | getName (void) const
| Gets resource name.
virtual ResourceHandle | getHandle (void) const
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual const String & | getGroup (void)
| Gets the group which this resource is a member of.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Protected Types
typedef list< Listener * >::type | ListenerList
## Protected Member Functions
virtual void | loadHighLevel (void)
| Internal load high-level portion if not loaded.
virtual void | unloadHighLevel (void)
| Internal unload high-level portion if loaded.
virtual void | loadHighLevelImpl (void)
| Internal load implementation, loads just the high-level portion, enough to get parameters.
virtual void | createLowLevelImpl (void)=0
| Internal method for creating an appropriate low-level program from this high-level program, must be implemented by subclasses.
virtual void | unloadHighLevelImpl (void)=0
| Internal unload implementation, must be implemented by subclasses.
virtual void | populateParameterNames (GpuProgramParametersSharedPtr params)
| Populate the passed parameters with name->index map.
virtual void | buildConstantDefinitions () const =0
| Build the constant definition map, must be overridden.
void | loadImpl ()
void | unloadImpl ()
void | setupBaseParamDictionary (void)
| Internal method for setting up the basic parameter definitions for a subclass.
bool | isRequiredCapabilitiesSupported (void) const
| Internal method returns whether required capabilities for this program is supported.
size_t | calculateSize (void) const
void | createParameterMappingStructures (bool recreateIfExists=true) const
| Create the internal params logical & named mapping structures.
void | createLogicalParameterMappingStructures (bool recreateIfExists=true) const
| Create the internal params logical mapping structures.
void | createNamedParameterMappingStructures (bool recreateIfExists=true) const
| Create the internal params named mapping structures.
virtual void | loadFromSource (void)=0
| Virtual method which must be implemented by subclasses, load from mSource.
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | postLoadImpl (void)
| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
virtual void | prepareImpl (void)
| Internal implementation of the meat of the 'prepare' action.
virtual void | unprepareImpl (void)
| Internal function for undoing the 'prepare' action.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
bool | mHighLevelLoaded
| Whether the high-level program (and it's parameter defs) is loaded.
GpuProgramPtr | mAssemblerProgram
| The underlying assembler program.
bool | mConstantDefsBuilt
| Have we built the name->index parameter map yet?
GpuProgramType | mType
| The type of the program.
String | mFilename
| The name of the file to load source from (may be blank).
String | mSource
| The assembler source of the program (may be blank until file loaded).
bool | mLoadFromFile
| Whether we need to load source from file or not.
String | mSyntaxCode
| Syntax code e.g. arbvp1, vs_2_0 etc.
bool | mSkeletalAnimation
| Does this (vertex) program include skeletal animation?
bool | mMorphAnimation
| Does this (vertex) program include morph animation?
ushort | mPoseAnimation
| Does this (vertex) program include pose animation (count of number of poses supported).
bool | mVertexTextureFetch
| Does this (vertex) program require support for vertex texture fetch?
bool | mNeedsAdjacencyInfo
| Does this (geometry) program require adjacency information?
GpuProgramParametersSharedPtr | mDefaultParams
| The default parameters for use with this object.
bool | mCompileError
| Did we encounter a compilation error?
GpuLogicalBufferStructPtr | mFloatLogicalToPhysical
| Record of logical to physical buffer maps.
GpuLogicalBufferStructPtr | mIntLogicalToPhysical
| Record of logical to physical buffer maps.
GpuNamedConstantsPtr | mConstantDefs
| Parameter name -> ConstantDefinition map, shared instance used by all parameter objects.
String | mManualNamedConstantsFile
| File from which to load named constants manually.
bool | mLoadedManualNamedConstants
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
AtomicScalar< LoadingState > | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
size_t | mStateCount
| State count, the number of times this resource has changed state.
ListenerList | mListenerList
## Static Protected Attributes
static CmdType | msTypeCmd
static CmdSyntax | msSyntaxCmd
static CmdSkeletal | msSkeletalCmd
static CmdMorph | msMorphCmd
static CmdPose | msPoseCmd
static CmdVTF | msVTFCmd
static CmdManualNamedConstsFile | msManNamedConstsFileCmd
static CmdAdjacency | msAdjacencyCmd

## Detailed Description

Abstract base class representing a high-level program (a vertex or fragment program).

Remarks:
  High-level programs are vertex and fragment programs written in a high-level language such as Cg or HLSL, and as such do not require you to write assembler code like GpuProgram does. However, the high-level program does eventually get converted (compiled) into assembler and then eventually microcode which is what runs on the GPU. As well as the convenience, some high-level languages like Cg allow you to write a program which will operate under both Direct3D and OpenGL, something which you cannot do with just GpuProgram (which requires you to write 2 programs and use each in a Technique to provide cross-API compatibility). Ogre will be creating a GpuProgram for you based on the high-level program, which is compiled specifically for the API being used at the time, but this process is transparent.

  You cannot create high-level programs direct - use HighLevelGpuProgramManager instead. Plugins can register new implementations of HighLevelGpuProgramFactory in order to add support for new languages without requiring changes to the core Ogre API. To allow custom parameters to be set, this class extends StringInterface - the application can query on the available custom parameters and get/set them without having to link specifically with it.

Definition at line 63 of file OgreHighLevelGpuProgram.h.

## Member Typedef Documentation

typedef list<Listener*>::type Ogre::Resource::ListenerList`[protected, inherited]`

Definition at line 164 of file OgreResource.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState`[inherited]`

Enum identifying the loading state of the resource.

Enumerator:

  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.
  LOADSTATE_PREPARED | Fully prepared.
  LOADSTATE_PREPARING | Preparing is in progress.

Definition at line 125 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::HighLevelGpuProgram::HighLevelGpuProgram | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0` |
| ) |  |  |

Constructor, should be used only by factory classes.

Ogre::HighLevelGpuProgram::~HighLevelGpuProgram | ( |  | ) |

## Member Function Documentation

virtual void Ogre::Resource::_dirtyState | ( |  | ) | `[virtual, inherited]`

Manually mark the state of this resource as having been changed.

Remarks:
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also:
  getStateCount.

virtual void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) | `[virtual, inherited]`

Firing of loading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters:

  | wasBackgroundLoaded | Whether this was a background loaded event

virtual void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) | `[virtual, inherited]`

Firing of preparing complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters:

  | wasBackgroundLoaded | Whether this was a background loaded event

virtual void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) | `[virtual, inherited]`

Firing of unloading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

GpuProgram* Ogre::HighLevelGpuProgram::_getBindingDelegate | ( | void |  | ) | `[virtual]`

Reimplemented from Ogre::GpuProgram.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 116 of file OgreHighLevelGpuProgram.h.

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[virtual, inherited]`

Notify this resource of it's origin.

Definition at line 420 of file OgreResource.h.

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[virtual, inherited]`

Register a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::HighLevelGpuProgram::buildConstantDefinitions | ( |  | ) | const`[protected, pure virtual]`

Build the constant definition map, must be overridden.

Note:
  The implementation must fill in the (inherited) mConstantDefs field at a minimum, and if the program requires that parameters are bound using logical parameter indexes then the mFloatLogicalToPhysical and mIntLogicalToPhysical maps must also be populated.

Implemented in Ogre::UnifiedHighLevelGpuProgram.

size_t Ogre::GpuProgram::calculateSize | ( | void |  | ) | const`[protected, virtual, inherited]`

Calculate the size of a resource; this will only be called after 'load'.

Implements Ogre::Resource.

Definition at line 189 of file OgreGpuProgram.h.

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[virtual, inherited]`

Change the resource group ownership of a Resource.

Remarks:
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters:

  | newGroup | Name of the new group

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 301 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

void Ogre::GpuProgram::createLogicalParameterMappingStructures | ( | bool | recreateIfExists = `true` | ) | const`[protected, inherited]`

Create the internal params logical mapping structures.

virtual void Ogre::HighLevelGpuProgram::createLowLevelImpl | ( | void |  | ) | `[protected, pure virtual]`

Internal method for creating an appropriate low-level program from this high-level program, must be implemented by subclasses.

Implemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::GpuProgram::createNamedParameterMappingStructures | ( | bool | recreateIfExists = `true` | ) | const`[protected, inherited]`

Create the internal params named mapping structures.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 184 of file OgreStringInterface.h.

References OGRE_LOCK_MUTEX.

void Ogre::GpuProgram::createParameterMappingStructures | ( | bool | recreateIfExists = `true` | ) | const`[protected, inherited]`

Create the internal params logical & named mapping structures.

GpuProgramParametersSharedPtr Ogre::HighLevelGpuProgram::createParameters | ( | void |  | ) | `[virtual]`

Creates a new parameters object compatible with this program definition.

Remarks:
  Unlike low-level assembly programs, parameters objects are specific to the program and therefore must be created from it rather than by the HighLevelGpuProgramManager. This method creates a new instance of a parameters object containing the definition of the parameters this program understands.

Reimplemented from Ogre::GpuProgram.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::escalateLoading | ( |  | ) | `[virtual, inherited]`

Escalates the loading of a background loaded resource.

Remarks:
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

const GpuNamedConstants& Ogre::HighLevelGpuProgram::getConstantDefinitions | ( |  | ) | const`[virtual]`

Get the full list of GpuConstantDefinition instances.

Note:
  Only available if this parameters object has named parameters.

Reimplemented from Ogre::GpuProgram.

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[virtual, inherited]`

Gets the manager which created this resource.

Definition at line 411 of file OgreResource.h.

virtual GpuProgramParametersSharedPtr Ogre::GpuProgram::getDefaultParameters | ( | void |  | ) | `[virtual, inherited]`

Get a reference to the default parameters which are to be used for all uses of this program.

Remarks:
  A program can be set up with a list of default parameters, which can save time when using a program many times in a material with roughly the same settings. By retrieving the default parameters and populating it with the most used options, any new parameter objects created from this program afterwards will automatically include the default parameters; thus users of the program need only change the parameters which are unique to their own usage of the program.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | `[virtual, inherited]`

Gets the group which this resource is a member of.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 399 of file OgreResource.h.

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const`[virtual, inherited]`

Reimplemented in Ogre::SkeletonInstance.

Definition at line 317 of file OgreResource.h.

virtual const String& Ogre::GpuProgram::getLanguage | ( | void |  | ) | const`[virtual, inherited]`

Returns a string that specifies the language of the gpu programs as specified in a material script.

ie: asm, cg, hlsl, glsl

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[virtual, inherited]`

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 348 of file OgreResource.h.

virtual const String& Ogre::GpuProgram::getManualNamedConstantsFile | ( |  | ) | const`[virtual, inherited]`

Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.

Definition at line 409 of file OgreGpuProgram.h.

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const`[virtual, inherited]`

Gets resource name.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 312 of file OgreResource.h.

const GpuNamedConstants& Ogre::HighLevelGpuProgram::getNamedConstants | ( |  | ) | const`[virtual]`

Override GpuProgram::getNamedConstants to ensure built.

Reimplemented from Ogre::GpuProgram.

Definition at line 125 of file OgreHighLevelGpuProgram.h.

virtual ushort Ogre::GpuProgram::getNumberOfPosesIncluded | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.

Definition at line 307 of file OgreGpuProgram.h.

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[virtual, inherited]`

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 418 of file OgreResource.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 217 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 222 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 270 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual bool Ogre::GpuProgram::getPassFogStates | ( | void |  | ) | const`[virtual, inherited]`

Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).

Remarks:
  On DirectX, shader model 2 and earlier continues to have fixed-function fog applied to it, so fog state is still passed (you should disable fog on the pass if you want to perform fog in the shader). In OpenGL it is also common to be able to access the fixed-function fog state inside the shader.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 358 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::getPassSurfaceAndLightStates | ( | void |  | ) | const`[virtual, inherited]`

Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).

Remarks:
  Most vertex programs do not need this material information, however GLSL shaders can refer to this material and lighting state so enable this option

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 348 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::getPassTransformStates | ( | void |  | ) | const`[virtual, inherited]`

Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.

Remarks:
  Most vertex programs do not need fixed-function transform information, however GLSL shaders can refer to this state so enable this option

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 366 of file OgreGpuProgram.h.

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const`[virtual, inherited]`

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 301 of file OgreResource.h.

virtual const String& Ogre::GpuProgram::getSource | ( | void |  | ) | const`[virtual, inherited]`

Gets the assembler source for this program.

Definition at line 229 of file OgreGpuProgram.h.

virtual const String& Ogre::GpuProgram::getSourceFile | ( | void |  | ) | const`[virtual, inherited]`

Gets the name of the file used as source for this program.

Definition at line 227 of file OgreGpuProgram.h.

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const`[virtual, inherited]`

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

Definition at line 429 of file OgreResource.h.

virtual const String& Ogre::GpuProgram::getSyntaxCode | ( | void |  | ) | const`[virtual, inherited]`

Gets the syntax code for this program e.g.

arbvp1, fp20, vs_1_1 etc

Definition at line 221 of file OgreGpuProgram.h.

virtual GpuProgramType Ogre::GpuProgram::getType | ( | void |  | ) | const`[virtual, inherited]`

Get the program type.

Definition at line 233 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::hasCompileError | ( | void |  | ) | const`[virtual, inherited]`

Did this program encounter a compile error when loading?

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 375 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::hasDefaultParameters | ( | void |  | ) | const`[virtual, inherited]`

Returns true if default parameters have been set up.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 340 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::isAdjacencyInfoRequired | ( | void |  | ) | const`[virtual, inherited]`

Returns whether this geometry program requires adjacency information from the input primitives.

Definition at line 324 of file OgreGpuProgram.h.

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[virtual, inherited]`

Returns whether this Resource has been earmarked for background loading.

Remarks:
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 365 of file OgreResource.h.

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 332 of file OgreResource.h.

virtual bool Ogre::Resource::isLoading | ( |  | ) | const`[virtual, inherited]`

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 341 of file OgreResource.h.

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[virtual, inherited]`

Is this resource manually loaded?

Definition at line 289 of file OgreResource.h.

virtual bool Ogre::GpuProgram::isMorphAnimationIncluded | ( | void |  | ) | const`[virtual, inherited]`

Returns whether a vertex program includes the required instructions to perform morph animation.

Remarks:
  If this returns true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 295 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::isPoseAnimationIncluded | ( | void |  | ) | const`[virtual, inherited]`

Returns whether a vertex program includes the required instructions to perform pose animation.

Remarks:
  If this returns true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 303 of file OgreGpuProgram.h.

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource has been prepared, false otherwise.

Definition at line 324 of file OgreResource.h.

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 282 of file OgreResource.h.

bool Ogre::GpuProgram::isRequiredCapabilitiesSupported | ( | void |  | ) | const`[protected, inherited]`

Internal method returns whether required capabilities for this program is supported.

virtual bool Ogre::GpuProgram::isSkeletalAnimationIncluded | ( | void |  | ) | const`[virtual, inherited]`

Returns whether a vertex program includes the required instructions to perform skeletal animation.

Remarks:
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 268 of file OgreGpuProgram.h.

virtual bool Ogre::GpuProgram::isSupported | ( | void |  | ) | const`[virtual, inherited]`

Returns whether this program can be supported on the current renderer and hardware.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual bool Ogre::GpuProgram::isVertexTextureFetchRequired | ( | void |  | ) | const`[virtual, inherited]`

Returns whether this vertex program requires support for vertex texture fetch from the hardware.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 315 of file OgreGpuProgram.h.

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters:

  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::GpuProgram::loadFromSource | ( | void |  | ) | `[protected, pure virtual, inherited]`

Virtual method which must be implemented by subclasses, load from mSource.

Implemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::HighLevelGpuProgram::loadHighLevel | ( | void |  | ) | `[protected, virtual]`

Internal load high-level portion if not loaded.

virtual void Ogre::HighLevelGpuProgram::loadHighLevelImpl | ( | void |  | ) | `[protected, virtual]`

Internal load implementation, loads just the high-level portion, enough to get parameters.

void Ogre::HighLevelGpuProgram::loadImpl | ( |  | ) | `[protected, virtual]`

Internal implementation of the meat of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader.

Reimplemented from Ogre::GpuProgram.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::HighLevelGpuProgram::populateParameterNames | ( | GpuProgramParametersSharedPtr | params | ) | `[protected, virtual]`

Populate the passed parameters with name->index map.

virtual void Ogre::Resource::postLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Reimplemented in Ogre::Mesh.

Definition at line 189 of file OgreResource.h.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 199 of file OgreResource.h.

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Definition at line 182 of file OgreResource.h.

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters:

  | backgroundThread | Whether this is occurring in a background thread

virtual void Ogre::Resource::prepareImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal implementation of the meat of the 'prepare' action.

Reimplemented in Ogre::Material, Ogre::Mesh, and Ogre::PatchMesh.

Definition at line 203 of file OgreResource.h.

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the unload process.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 194 of file OgreResource.h.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual, inherited]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[virtual, inherited]`

Remove a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::GpuProgram::resetCompileError | ( | void |  | ) | `[virtual, inherited]`

Reset a compile error if it occurred, allowing the load to be retried.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 379 of file OgreGpuProgram.h.

virtual void Ogre::GpuProgram::setAdjacencyInfoRequired | ( | bool | r | ) | `[virtual, inherited]`

Sets whether this geometry program requires adjacency information from the input primitives.

Definition at line 320 of file OgreGpuProgram.h.

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[virtual, inherited]`

Tells the resource whether it is background loaded or not.

Remarks:

See also:
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 375 of file OgreResource.h.

virtual void Ogre::GpuProgram::setManualNamedConstants | ( | const GpuNamedConstants & | namedConstants | ) | `[virtual, inherited]`

Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.

Remarks:
  You may wish to use this if you have assembler programs that were compiled from a high-level source, and want the convenience of still being able to use the named parameters from the original high-level source.

See also:
  setManualNamedConstantsFile

virtual void Ogre::GpuProgram::setManualNamedConstantsFile | ( | const String & | paramDefFile | ) | `[virtual, inherited]`

Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.

Remarks:
  You may wish to use this if you have assembler programs that were compiled from a high-level source, and want the convenience of still being able to use the named parameters from the original high-level source. This method will make a low-level program search in the resource group of the program for the named file from which to load parameter names from. The file must be in the format produced by GpuNamedConstants::save.

virtual void Ogre::GpuProgram::setMorphAnimationIncluded | ( | bool | included | ) | `[virtual, inherited]`

Sets whether a vertex program includes the required instructions to perform morph animation.

Remarks:
  If this is set to true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

Definition at line 276 of file OgreGpuProgram.h.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual void Ogre::GpuProgram::setPoseAnimationIncluded | ( | ushort | poseCount | ) | `[virtual, inherited]`

Sets whether a vertex program includes the required instructions to perform pose animation.

Remarks:
  If this is set to true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Parameters:

  | poseCount | The number of simultaneous poses the program can blend

Definition at line 286 of file OgreGpuProgram.h.

virtual void Ogre::GpuProgram::setSkeletalAnimationIncluded | ( | bool | included | ) | `[virtual, inherited]`

Sets whether a vertex program includes the required instructions to perform skeletal animation.

Remarks:
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

Definition at line 259 of file OgreGpuProgram.h.

virtual void Ogre::GpuProgram::setSource | ( | const String & | source | ) | `[virtual, inherited]`

Sets the source assembly for this program from an in-memory string.

Remarks:
  Setting this will have no effect until you (re)load the program.

virtual void Ogre::GpuProgram::setSourceFile | ( | const String & | filename | ) | `[virtual, inherited]`

Sets the filename of the source assembly for this program.

Remarks:
  Setting this will have no effect until you (re)load the program.

virtual void Ogre::GpuProgram::setSyntaxCode | ( | const String & | syntax | ) | `[virtual, inherited]`

Sets the syntax code for this program e.g.

arbvp1, fp20, vs_1_1 etc

virtual void Ogre::GpuProgram::setType | ( | GpuProgramType | t | ) | `[virtual, inherited]`

Set the program type (only valid before load).

void Ogre::GpuProgram::setupBaseParamDictionary | ( | void |  | ) | `[protected, inherited]`

Internal method for setting up the basic parameter definitions for a subclass.

Remarks:
  Because StringInterface holds a dictionary of parameters per class, subclasses need to call this to ask the base class to add it's parameters to their dictionary as well. Can't do this in the constructor because that runs in a non-virtual context.

  The subclass must have called it's own createParamDictionary before calling this method.

virtual void Ogre::GpuProgram::setVertexTextureFetchRequired | ( | bool | r | ) | `[virtual, inherited]`

Sets whether this vertex program requires support for vertex texture fetch from the hardware.

Definition at line 311 of file OgreGpuProgram.h.

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual, inherited]`

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::Material, and Ogre::UnifiedHighLevelGpuProgram.

Referenced by Ogre::Material::touch().

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual, inherited]`

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::HighLevelGpuProgram::unloadHighLevel | ( | void |  | ) | `[protected, virtual]`

Internal unload high-level portion if loaded.

virtual void Ogre::HighLevelGpuProgram::unloadHighLevelImpl | ( | void |  | ) | `[protected, pure virtual]`

Internal unload implementation, must be implemented by subclasses.

Implemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::HighLevelGpuProgram::unloadImpl | ( |  | ) | `[protected, virtual]`

Internal implementation of the 'unload' action; called regardless of whether this resource is being loaded from a ManualResourceLoader.

Implements Ogre::Resource.

virtual void Ogre::Resource::unprepareImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal function for undoing the 'prepare' action.

Called when the load is completed, and when resources are unloaded when they are prepared but not yet loaded.

Reimplemented in Ogre::Material, and Ogre::Mesh.

Definition at line 208 of file OgreResource.h.

## Member Data Documentation

GpuProgramPtr Ogre::HighLevelGpuProgram::mAssemblerProgram`[protected]`

The underlying assembler program.

Definition at line 69 of file OgreHighLevelGpuProgram.h.

bool Ogre::GpuProgram::mCompileError`[protected, inherited]`

Did we encounter a compilation error?

Definition at line 153 of file OgreGpuProgram.h.

GpuNamedConstantsPtr Ogre::GpuProgram::mConstantDefs`[mutable, protected, inherited]`

Parameter name -> ConstantDefinition map, shared instance used by all parameter objects.

This is a shared pointer because if the program is recompiled and the parameters change, this definition will alter, but previous params may reference the old def.

Definition at line 168 of file OgreGpuProgram.h.

bool Ogre::HighLevelGpuProgram::mConstantDefsBuilt`[mutable, protected]`

Have we built the name->index parameter map yet?

Definition at line 71 of file OgreHighLevelGpuProgram.h.

ResourceManager* Ogre::Resource::mCreator`[protected, inherited]`

Creator.

Definition at line 142 of file OgreResource.h.

GpuProgramParametersSharedPtr Ogre::GpuProgram::mDefaultParams`[protected, inherited]`

The default parameters for use with this object.

Definition at line 151 of file OgreGpuProgram.h.

String Ogre::GpuProgram::mFilename`[protected, inherited]`

The name of the file to load source from (may be blank).

Definition at line 133 of file OgreGpuProgram.h.

GpuLogicalBufferStructPtr Ogre::GpuProgram::mFloatLogicalToPhysical`[mutable, protected, inherited]`

Record of logical to physical buffer maps.

Mandatory for low-level programs or high-level programs which set their params the same way. This is a shared pointer because if the program is recompiled and the parameters change, this definition will alter, but previous params may reference the old def.

Definition at line 158 of file OgreGpuProgram.h.

String Ogre::Resource::mGroup`[protected, inherited]`

The name of the resource group.

Definition at line 146 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected, inherited]`

Numeric handle for more efficient look up than name.

Definition at line 148 of file OgreResource.h.

bool Ogre::HighLevelGpuProgram::mHighLevelLoaded`[protected]`

Whether the high-level program (and it's parameter defs) is loaded.

Definition at line 67 of file OgreHighLevelGpuProgram.h.

GpuLogicalBufferStructPtr Ogre::GpuProgram::mIntLogicalToPhysical`[mutable, protected, inherited]`

Record of logical to physical buffer maps.

Mandatory for low-level programs or high-level programs which set their params the same way. This is a shared pointer because if the program is recompiled and the parameters change, this definition will alter, but previous params may reference the old def.

Definition at line 163 of file OgreGpuProgram.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected, inherited]`

Is this resource going to be background loaded? Only applicable for multithreaded.

Definition at line 152 of file OgreResource.h.

bool Ogre::Resource::mIsManual`[protected, inherited]`

Is this file manually loaded?

Definition at line 156 of file OgreResource.h.

ListenerList Ogre::Resource::mListenerList`[protected, inherited]`

Definition at line 165 of file OgreResource.h.

bool Ogre::GpuProgram::mLoadedManualNamedConstants`[protected, inherited]`

Definition at line 171 of file OgreGpuProgram.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected, inherited]`

Optional manual loader; if provided, data is loaded from here instead of a file.

Definition at line 160 of file OgreResource.h.

bool Ogre::GpuProgram::mLoadFromFile`[protected, inherited]`

Whether we need to load source from file or not.

Definition at line 137 of file OgreGpuProgram.h.

AtomicScalar<LoadingState> Ogre::Resource::mLoadingState`[protected, inherited]`

Is the resource currently loaded?

Definition at line 150 of file OgreResource.h.

String Ogre::GpuProgram::mManualNamedConstantsFile`[protected, inherited]`

File from which to load named constants manually.

Definition at line 170 of file OgreGpuProgram.h.

bool Ogre::GpuProgram::mMorphAnimation`[protected, inherited]`

Does this (vertex) program include morph animation?

Definition at line 143 of file OgreGpuProgram.h.

String Ogre::Resource::mName`[protected, inherited]`

Unique name of the resource.

Definition at line 144 of file OgreResource.h.

bool Ogre::GpuProgram::mNeedsAdjacencyInfo`[protected, inherited]`

Does this (geometry) program require adjacency information?

Definition at line 149 of file OgreGpuProgram.h.

String Ogre::Resource::mOrigin`[protected, inherited]`

Origin of this resource (e.g. script name) - optional.

Definition at line 158 of file OgreResource.h.

ushort Ogre::GpuProgram::mPoseAnimation`[protected, inherited]`

Does this (vertex) program include pose animation (count of number of poses supported).

Definition at line 145 of file OgreGpuProgram.h.

CmdAdjacency Ogre::GpuProgram::msAdjacencyCmd`[static, protected, inherited]`

Definition at line 129 of file OgreGpuProgram.h.

size_t Ogre::Resource::mSize`[protected, inherited]`

The size of the resource in bytes.

Definition at line 154 of file OgreResource.h.

bool Ogre::GpuProgram::mSkeletalAnimation`[protected, inherited]`

Does this (vertex) program include skeletal animation?

Definition at line 141 of file OgreGpuProgram.h.

CmdManualNamedConstsFile Ogre::GpuProgram::msManNamedConstsFileCmd`[static, protected, inherited]`

Definition at line 128 of file OgreGpuProgram.h.

CmdMorph Ogre::GpuProgram::msMorphCmd`[static, protected, inherited]`

Definition at line 125 of file OgreGpuProgram.h.

String Ogre::GpuProgram::mSource`[protected, inherited]`

The assembler source of the program (may be blank until file loaded).

Definition at line 135 of file OgreGpuProgram.h.

CmdPose Ogre::GpuProgram::msPoseCmd`[static, protected, inherited]`

Definition at line 126 of file OgreGpuProgram.h.

CmdSkeletal Ogre::GpuProgram::msSkeletalCmd`[static, protected, inherited]`

Definition at line 124 of file OgreGpuProgram.h.

CmdSyntax Ogre::GpuProgram::msSyntaxCmd`[static, protected, inherited]`

Definition at line 123 of file OgreGpuProgram.h.

size_t Ogre::Resource::mStateCount`[protected, inherited]`

State count, the number of times this resource has changed state.

Definition at line 162 of file OgreResource.h.

CmdType Ogre::GpuProgram::msTypeCmd`[static, protected, inherited]`

Definition at line 122 of file OgreGpuProgram.h.

CmdVTF Ogre::GpuProgram::msVTFCmd`[static, protected, inherited]`

Definition at line 127 of file OgreGpuProgram.h.

String Ogre::GpuProgram::mSyntaxCode`[protected, inherited]`

Syntax code e.g. arbvp1, vs_2_0 etc.

Definition at line 139 of file OgreGpuProgram.h.

GpuProgramType Ogre::GpuProgram::mType`[protected, inherited]`

The type of the program.

Definition at line 131 of file OgreGpuProgram.h.

bool Ogre::GpuProgram::mVertexTextureFetch`[protected, inherited]`

Does this (vertex) program require support for vertex texture fetch?

Definition at line 147 of file OgreGpuProgram.h.

The documentation for this class was generated from the following file:

- OgreHighLevelGpuProgram.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:55